# -*- coding: cp1250 -*-
# Single Flow 8-Direction
# Created by Bc. Petr Novk, 2015/04
# Faculty of Environmental Sciences
# Czech University of Life Sciences Prague 

"""
Skript obsahuje dv pomocn funkce: neighbors a slope.
Neighbors hled elevaci sousednch bunk.
Slope pot sklon do kad sousedn buky.
Zbvajc st skriptu nate vstupn DEM,
pevede jej na array a nsledn prochz
array a pro kadou poloku (buku DEM) hled
smr odtoku s nejvtm sklonem a souasn
ovuje, e se nejedn o bezodtokovu plochu. 
"""

import os, math, arcpy
import numpy as np
import rta as rt
arcpy.env.overwriteOutput = True

# Funkce hled elevaci sousednch bunk
def neighbors_z(array,x,y):
    n1=array[x,y+1]
    n2=array[x+1,y+1]
    n4=array[x+1,y]
    n8=array[x+1,y-1]
    n16=array[x,y-1]
    n32=array[x-1,y-1]
    n64=array[x-1,y]
    n128=array[x-1,y+1]
    return n1, n2, n4, n8, n16, n32, n64, n128

# Funkce hled nejvt sklon
def slope (cell, nb, vCell):
    slp=[]
    for k in range(8):
        if k%2==0:
            s=(cell-nb[k])/vCell
        else:
            s=(cell-nb[k])/vCellSqrt
        slp.append(s)
    return slp

arcpy.AddMessage("Natm data... ")
# Vstupy:
# Rastr DEM
in_dem = sys.argv[1]
# Nate rastr DEM do np.array
ar_dem = rt.rta(in_dem)
XMax = ar_dem[1]
YMax = ar_dem[2]
vCell = ar_dem[3]
LeftX = ar_dem[4]
LextY = ar_dem[5]
vCellSqrt = vCell*math.sqrt(2)

# Vstupy:
# Rastr smr odtok
out_ras = sys.argv[2]

arcpy.AddMessage("Data natena, zan vpoet")
# Vytvo array nulovch hodnot
dir_aray = np.zeros([XMax,YMax])

# Hodnoty pro uren smr odtok
rastr_dir=[1,2,4,8,16,32,64,128]

# Prohled cely rastr  
for x in range (1,XMax-1):
    for y in range (1,YMax-1):
        # Stanov smr odtoku vem bukm
        slp=slope(ar_dem[0][x][y],neighbors_z(ar_dem[0],x,y),vCell)
        if (max(slp)) <= 0:
            arcpy.AddError(str("Chyba rastru(ploina nebo deprese),sklon je=")+str(max(slp)))           
            break
        idx = slp.index(max(slp))
        # Zape smr odtoku do array 
        dir_aray[x,y]=rastr_dir[idx]
    # Kontrola bezodtokovch ploch
    if (max(slp)) <= 0:
        arcpy.AddError(str("Chyba rastru(ploina nebo deprese),sklon je=")+str(max(slp)))
        break
arcpy.AddMessage("Zapisuji vsledek")
#Vytvo rastr smr odtok
new_raster = arcpy.NumPyArrayToRaster(dir_aray,arcpy.Point(LeftX,LextY),vCell,value_to_nodata=-9999) 
new_raster.save(out_ras)
